using UnityEngine;
using System.Collections;

public class BulletManager : MonoBehaviour {

    private static BulletManager instance;
    private static GameObject container;

    private Quaternion bulletRotation = new Quaternion(0, -0.7f, 0, 0.7f);

    public static BulletManager GetInstance()
    {
        if (!instance)
        {
            container = new GameObject();
            container.name = "BulletManager";
            instance = container.AddComponent(typeof(BulletManager)) as BulletManager;
        }
        return instance;
    }

    public void CreateBullet(string type, Vector3 location, Quaternion rotation, float speed, float life)
    {
        GameObject bullet;
        TowerBulletBasic tscript;

        switch (type)
        {
            case "PlayerShot":
                bullet = (GameObject)GameObject.Instantiate(Resources.Load("PlayerBulletPrefab"), location, rotation * bulletRotation);
                PlayerProjectile bscript = bullet.GetComponent <PlayerProjectile>();

                bscript.speed = speed;
                bscript.life = life;
                break;

            case "TowerBasic":    
                bullet = (GameObject)GameObject.Instantiate(Resources.Load("TowerBullet"), location, rotation * bulletRotation);
                tscript = bullet.GetComponent <TowerBulletBasic>();

                tscript.speed = speed;
                tscript.life = life;
                break;

            case "TowerBasicBig":
                bullet = (GameObject)GameObject.Instantiate(Resources.Load("TowerBulletBig"), location, rotation * bulletRotation);
                tscript = bullet.GetComponent<TowerBulletBasic>();

                tscript.speed = speed;
                tscript.life = life;
                break;
        }
    }

	// Use this for initialization
	void Start () {
        
	}
	
	// Update is called once per frame
	void Update () {
	
	}
}
