using UnityEngine;
using System.Collections;

public class CameraController : MonoBehaviour {

    public GameObject player;
    public GameObject target;
    public GameObject warning;
    public GameObject bossname;

    public int height;

    Vector3 lastPosition;

    private GameManager gm;

	// Use this for initialization
	void Start () {
        warning.active = false;
        bossname.active = false;

        gm = GameManager.GetInstance();

        height = 200;
	}
	
	// Update is called once per frame
	void Update () {
        if (gm.state == (int)GameManager.gameState.stateActive)
        {
            FollowPlayerTargetMidpoint();
        }
	}

    public void FollowPlayerOnly()
    {
        Vector3 pointat = player.transform.position;
        pointat.y = height;
        transform.position = pointat;

        pointat.y = 0;
        transform.LookAt(pointat);
    }

    public void FollowPlayerTargetMidpoint()
    {
        Vector3 pointat;

        if(target)
            pointat = (target.transform.position + player.transform.position) * 0.5f;
        else
            pointat = (lastPosition + player.transform.position) * 0.5f;

        pointat.y = height;
        transform.position = pointat;

        pointat.y = 0;
        transform.LookAt(pointat);

        if(target)
            lastPosition = new Vector3(target.transform.position.x, target.transform.position.y, target.transform.position.z);
    }

    public void ChangeTargetObject(GameObject newtarget)
    {
        target = newtarget;
    }

    public IEnumerator flashWarning(int flashcount)
    {
        warning.active = true;

        iTween.FadeTo(warning, iTween.Hash("alpha", 1f, "time", 0.2f));
        yield return new WaitForSeconds(0.3f);
        iTween.FadeTo(warning, iTween.Hash("alpha", 0f, "time", 0.8f));
        yield return new WaitForSeconds(0.8f);

        if (flashcount > 1)
            StartCoroutine(flashWarning(flashcount - 1));
        else
            Destroy(warning);
    }

    public IEnumerator showBossName(float seconds)
    {
        bossname.active = true;

        yield return new WaitForSeconds(2f);

        gm.startMusic(); //Why is this in the camera controller?  WHO KNOWS!

        iTween.FadeTo(bossname, iTween.Hash("alpha", 1f, "time", 1f));
        yield return new WaitForSeconds(seconds);
        iTween.FadeTo(bossname, iTween.Hash("alpha", 0f, "time", 1f));
        yield return new WaitForSeconds(1f);
        Destroy(bossname);
    }
}
