using UnityEngine;
using System.Collections;

public class PlayerProjectile : MonoBehaviour {

    public float speed = 350;
    public float life = 3f;

    private bool moving;

	// Use this for initialization
	void Start () {
        moving = true;
	}
	
	// Update is called once per frame
	void Update () {
        if(moving)
            transform.Translate(0f, 0f, speed * Time.deltaTime);

        if(!IsInvoking("Autodestruct"))
            Invoke("Autodestruct",life);
	}

    void Autodestruct()
    {
        Destroy(this.gameObject);
    }

    void OnTriggerEnter(Collider other)
    {
        if (other.tag == "Enemy")
        {
            //Debug.Log("Enemy Hit!");
            moving = false;

            GameManager gm = GameManager.GetInstance();
            gm.DamageTarget(1); //Change this for debugging!

            GameObject.Instantiate(Resources.Load("Detonator-Simple"),gameObject.transform.position,Quaternion.identity);
        }
    }
}