using UnityEngine;
using System.Collections;

public class TowerBulletBasic : MonoBehaviour {

    public float speed = 350;
    public float life = 10;

    private bool moving;

    // Use this for initialization
    void Start()
    {
        moving = true;
    }

    // Update is called once per frame
    void Update()
    {
        if (moving)
            transform.Translate(0f, 0f, speed * Time.deltaTime);

        if (!IsInvoking("Autodestruct"))
            Invoke("Autodestruct", life);
    }

    void Autodestruct()
    {
        GameObject.Instantiate(Resources.Load("Detonator-Simple"), gameObject.transform.position, Quaternion.identity); //Blow up if destroyed
        Destroy(this.gameObject);
    }

    public IEnumerator DieAfterDistance(GameObject player)
    {

        //Projectiles will be removed depending on their distance from the killing object.
        float dist = Vector3.Distance(player.transform.position, gameObject.transform.position)/250;

        yield return new WaitForSeconds(dist);
        if(this)
            Autodestruct();

        yield return null;
    }

    void OnTriggerEnter(Collider other)
    {
        if (other.tag == "Player")
        {
            //Debug.Log("Player Hit!");
            moving = false;

            GameObject.Find("PlayerController").GetComponent<Player>().TakeDamage();
            GameObject.Instantiate(Resources.Load("Detonator-Simple"), gameObject.transform.position, Quaternion.identity);

            Destroy(this.gameObject);
        }
    }
}
